#rem "DETEKTOR DUCHU"
- napajen ze dvou AAA clanku pres menic 0,5-3V / 3,3V
- LED 4x zelena, 2x zluta, 3x cervena v "parozi" (posledni LED ovladane samostatn)
- vstup z ovladaciho tahoveho potenciometru C.7
- vstup napeti baterii C.1 (3,00V = 230, 2,00V = 157)
- vystup zvuku na C.3 regulace tonu i hlasitosti pres PWM
- vystup LED B.7 - B.0, dve posledni cervene na C.4 a C.5
- vystup LED c.2 - zelena kontrolka napajeni a podpeti
#endrem
#picaxe 20M2
#no_data
setfreq m16                                          ;musi byt kvuli blikani pri prevodu
pause 800
low c.2                                              ;rozsviceni kontrolky napajeni
pwmout pwmdiv16,C.3,249,0                            ;frekvence zvuku 1000 Hz
readadc c.7,w0                                       ;potenciometr nahore = mereni baterii
if b0>128 then gosub merbat                          ;odskok na mereni

do                                                   ;hlavni smycka programu
  readadc c.1,b0                                     ;prubezne mereni napeti
  inc b10                                            ;rychlost blikani kontrolky
  if b10>10 then let b10=0 endif                  
  if b0<=160 and b10=0 then toggle c.2 endif         ;blikat pod 2,0V
  if b0>160 then low c.2 endif                       ;vzdy skoncit s rozsvicenou kontrolkou
  readadc c.7,b1                                     ;mereni polohy potenciometru
  gosub zhasni                                       ;zhasnuti LED
  if b1>225 then high c.4,c.5 endif                  ;rozsviceni rady LED
  if b1>200 then low b.0 endif
  if b1>175 then low b.1 endif
  if b1>150 then low b.2 endif
  if b1>125 then low b.3 endif
  if b1>100 then low b.4 endif
  if b1 >75 then low b.5 endif
  if b1 >50 then low b.6 endif
  if b1 >25 then low b.7 endif          
  select b1                                          ;nastaveni periody pipani do b3 tabulkou
    case >225 let b3=1
    case >200 let b3=3  
    case >175 let b3=5
    case >150 let b3=8
    case >125 let b3=14          
    case >100 let b3=23
    case  >75 let b3=39
    case  >50 let b3=64
    case  >25 let b3=100
    endselect         
  inc b2                                             ;generovani zvuku s promennou periodou
  if b2>=b3 and b1>25 then let b2=0 pwmduty c.3,500 endif
  if b2>=1 then pwmduty c.3,0 endif
  pause 20
  loop                                               ;konec smycky programu

merbat:                                              ;uvodni mereni baterie
  low b.0,b.1,b.2,b.3,b.4,b.5,b.6,b.7 high c.4,c.5   ;vse rozsvitit
  pause 4000                                         ;pockat 1s kvuli zatizeni
  gosub zhasni                                       ;vse zhasnout 
opakuj:                                              ;smycka mereni do posunuti potenciometru dolu
  readadc c.1,b0                                     ;mereni napti
  select b0                                          ;meze 2 - 3 V
    case 222 to 255 low b.7 
    case 213 to 221 low b.6
    case 204 to 212 low b.5
    case 195 to 203 low b.4
    case 186 to 194 low b.3
    case 177 to 185 low b.2
    case 168 to 176 low b.1                  
    case 159 to 167 low b.0
    case   0 to 158 high c.4,c.5
    endselect 
  if b0<=176 then pwmduty c.3,80 endif               ;pipani ztisene pri cervenych LED
  pause 100
  pwmduty c.3,0
  gosub zhasni
  pause 700
  readadc c.7,b0                                     ;kontrola stazeni potenciometru
  if b0>128 then opakuj
  return

zhasni:                                              ;zhasnuti vsech LED krome kontrolky
  high b.0,b.1,b.2,b.3,b.4,b.5,b.6,b.7
  low c.4,c.5
  return